use std::{
	io::{prelude::*, BufReader},
	net::{TcpListener, TcpStream},
	str,
};
use rust_embed::RustEmbed;

#[derive(RustEmbed)]
#[folder = "./Articles"]
struct Asset;

fn main() {
	let listener = TcpListener::bind("0.0.0.0:7878").unwrap();
	
	for file in Asset::iter() {
		let page = Asset::get(&file.to_string()).unwrap();
		println!("{:?}", std::str::from_utf8(page.data.as_ref()));
	}


	for stream in listener.incoming() {
		let stream = stream.unwrap();

		handle_connection(stream);
	}
}

fn handle_connection(mut stream: TcpStream) {
	let buf_reader = BufReader::new(&mut stream);
	let request_line = buf_reader.lines().next().unwrap().unwrap();
	let mut content = "<html><head><strong>Error 404</strong><br /></head><body><img src=\"https://http.cat/404\"></img><br /><p>Not Found</p></body></html>";
	let mut page;
	let mut status_line = "HTTP/1.1 404 NOT FOUND";
	if request_line == "GET / HTTP/1.1" {
		status_line = "HTTP/1.1 200 OK";
		page = Asset::get("index.html").unwrap();
		content = std::str::from_utf8(page.data.as_ref()).unwrap();
	}else if request_line == "GET /style.css HTTP/1.1" {
		status_line = "HTTP/1.1 200 OK";
		page = Asset::get("style.css").unwrap();
		content = std::str::from_utf8(page.data.as_ref()).unwrap();
	}
	let status_line = "HTTP/1.1 200 OK";
	let length = content.len();
	let response = format!(
		"{}\r\nContent-Length: {}\r\n\r\n{}"
	, status_line, length, content);
	stream.write_all(response.as_bytes());
}
